"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _htmlWebpackPlugin() {
  const data = _interopRequireDefault(require("html-webpack-plugin"));

  _htmlWebpackPlugin = function _htmlWebpackPlugin() {
    return data;
  };

  return data;
}

var _addAllAssetsToCompilation = _interopRequireDefault(require("./addAllAssetsToCompilation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class AddAssetHtmlPlugin {
  constructor(assets = []) {
    this.assets = Array.isArray(assets) ? assets.slice().reverse() : [assets];
  }
  /* istanbul ignore next: this would be integration tests */


  apply(compiler) {
    compiler.hooks.compilation.tap('AddAssetHtmlPlugin', compilation => {
      let hook;

      if (_htmlWebpackPlugin().default.version === 4) {
        hook = _htmlWebpackPlugin().default.getHooks(compilation).beforeAssetTagGeneration;
      } else {
        hook = compilation.hooks.htmlWebpackPluginBeforeHtmlGeneration;
      }

      hook.tapPromise('AddAssetHtmlPlugin', htmlPluginData => (0, _addAllAssetsToCompilation.default)(this.assets, compilation, htmlPluginData));
    });
  }

}

exports.default = AddAssetHtmlPlugin;
module.exports = exports.default;